%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname activemodel
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}

%global testdir %{_tmppath}/%{gemname}-%{version}

Summary: A toolkit for building modeling frameworks
Name: rubygem-%{gemname}
Version: 3.0.13
Release: 3%{?dist}
Group: Development/Languages
License: MIT
URL: http://www.rubyonrails.org
Source0: http://rubygems.org/gems/%{gemname}-%{version}.gem
Patch0:   rubygem-activemodel-3-0-attr_protected-cve-2013-0276.patch
# git clone https://github.com/rails/rails.git && cd rails/activemodel && git checkout v3.0.13
# tar czvf activemodel-tests.tgz test/
Source1: %{gemname}-tests.tgz
Requires: ruby(abi) = 1.8
Requires: rubygems
Requires: rubygem(activesupport) = %{version}
Requires: rubygem(builder) => 2.1.2
Requires: rubygem(i18n) => 0.4.2
BuildRequires: rubygems
BuildRequires: rubygem(activesupport) = %{version}
BuildRequires: rubygem(builder)
BuildRequires: rubygem(i18n) => 0.4.2
BuildRequires: rubygem(mocha)
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}

# This is required in order for activerecord tests to pass after
# patches to activesupport/actionpack for CVE-2013-0156.
Patch1: activemodel-CVE-2013-0156-fixes.patch

%description
Rich support for attributes, callbacks, validations, observers,
serialization, internationalization, and testing. It provides a known
set of interfaces for usage in model classes. It also helps building
custom ORMs for use outside of the Rails framework.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires:%{name} = %{version}-%{release}

%description doc
Documentation for %{name}

%prep
%setup -q -c -T
mkdir -p .%{gemdir}
gem install --local --install-dir .%{gemdir} \
            --force %{SOURCE0}

# move the tests into place
tar xzvf %{SOURCE1} -C .%{geminstdir}

pushd .%{geminstdir}
%patch0 -p2
%patch1 -p2
popd

%build

%install
mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
        %{buildroot}%{gemdir}/

# Remove backup files
find %{buildroot}/%{geminstdir} -type f -name "*~" -delete

# Delete zero-length files
find %{buildroot}/%{geminstdir} -type f -size 0c -exec rm -rvf {} \;

# Fix anything executable that does not have a shebang
for file in `find %{buildroot}/%{geminstdir} -type f -perm /a+x`; do
    [ -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 644 $file
done

# Find files with a shebang that do not have executable permissions
for file in `find %{buildroot}/%{geminstdir} -type f ! -perm /a+x -name "*.rb"`; do
    [ ! -z "`head -n 1 $file | grep \"^#!/\"`" ] && chmod -v 755 $file
done

# Find files that have non-standard-executable-perm
find %{buildroot}/%{geminstdir} -type f -perm /g+wx -exec chmod -v g-w {} \;

# Find files that are not readable
find %{buildroot}/%{geminstdir} -type f ! -perm /go+r -exec chmod -v go+r {} \;

%check
rm -rf %{testdir}
mkdir %{testdir}
tar xzvf %{SOURCE1} -C %{testdir}
pushd %{testdir}

# load_path is not available, remove its require.
sed -i '1,2d' test/cases/helper.rb

RUBYOPT="rubygems I%{buildroot}%{geminstdir}/lib Itest" testrb test/*/*_test.rb test/*/*/*_test.rb

popd
rm -rf %{testdir}

%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%{geminstdir}/lib
%doc %{geminstdir}/README.rdoc
%doc %{geminstdir}/MIT-LICENSE
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec
%{geminstdir}/test

%files doc
%defattr(-, root, root, -)
%doc %{geminstdir}/CHANGELOG
%doc %{gemdir}/doc/%{gemname}-%{version}


%changelog
* Wed Feb 27 2013 Brenton Leanhardt <bleanhar@redhat.com> - 3.0.13-3
- Added patch to fix tests after activesupport CVE-2013-0156 fix

* Wed Feb 13 2013 Brenton Leanhardt <bleanhar@redhat.com> - 3.0.13-2
- Added patch for CVE-2013-0276
- fixed the prep section to allow for patching the gem

* Tue Jun 05 2012 Wesley Hearn <whearn@redhat.com> - 3.0.13-1
- Updated to 3.0.13

* Fri Mar 25 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.5-1
- Update to ActiveSupport 3.0.5

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Feb 03 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-3
- Removed unnecessary clean section.

* Mon Jan 31 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-2
- Added build dependencies.

* Tue Jan 25 2011 Vít Ondruch <vondruch@redhat.com> - 3.0.3-1
- Upgraded to activemodel 3.0.3
- Added documentation subpackage
- Added test execution during build
- Removed unnecessary cleanup from install section

* Tue Oct 26 2010 Jozef Zigmund <jzigmund@dhcp-29-238.brq.redhat.com> - 3.0.1-1
- Initial package
